#define WINVER 0x0501
#define _WIN32_WINNT 0x0501
#include <windows.h>
#include <string.h>

#include "tbwheeldll.h"

typedef WINUSERAPI INT (WINAPI *pGetRawInputDeviceList)(OUT PRAWINPUTDEVICELIST pRawInputDeviceList,IN OUT PUINT puiNumDevices,IN UINT cbSize);
typedef WINUSERAPI INT (WINAPI *pGetRawInputDeviceInfoA)(IN HANDLE hDevice,IN UINT uiCommand,OUT LPVOID pData,IN OUT PUINT pcbSize);
typedef WINUSERAPI INT (WINAPI *pGetRawInputData)(IN HRAWINPUT hRawInput,IN UINT uiCommand,OUT LPVOID pData,IN OUT PUINT pcbSize,IN UINT cbSizeHeader);
typedef WINUSERAPI BOOL (WINAPI *pRegisterRawInputDevices)(IN PCRAWINPUTDEVICE pRawInputDevices,IN UINT uiNumDevices,IN UINT cbSize);

static const char *wndcls="tbwheel raw mouse message class";

static pGetRawInputDeviceList gl;
static pGetRawInputDeviceInfoA gi;
static pGetRawInputData gd;
static pRegisterRawInputDevices gr;
static HINSTANCE inst;
static ATOM a;
static int enabled;
static DWORD th;
static CRITICAL_SECTION mtx;

static int seq=0;

typedef struct
{
	HANDLE h;
	HANDLE m;
	HANDLE e;
	HWND w;
	HWND hwnd;
	int k;
} DATA;

static LRESULT CALLBACK llmp(int nCode,WPARAM wParam,LPARAM lParam)
{
	MSLLHOOKSTRUCT *d=(MSLLHOOKSTRUCT *)lParam;

	if(nCode<0)return CallNextHookEx(NULL,nCode,wParam,lParam);
	if(d->flags&LLMHF_INJECTED)return CallNextHookEx(NULL,nCode,wParam,lParam);
	return TRUE;
}

static LRESULT CALLBACK wp(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	int t;
	int f=0;
	HANDLE q;
	UINT u;
	DATA *d;
	RAWINPUTHEADER *h;
	RAWINPUT *r;
	INPUT j[3];
	char bfr[512];

	d=TlsGetValue(th);

	switch(uMsg)
	{
	case WM_INPUT:
		if(wParam==-1)break;
		if(gd((HRAWINPUT)lParam,RID_HEADER,NULL,&u,sizeof(RAWINPUTHEADER)))break;
		if(u<=sizeof(bfr))h=(RAWINPUTHEADER *)bfr;
		else if(!(h=malloc(u)))break;
		if(gd((HRAWINPUT)lParam,RID_HEADER,h,&u,sizeof(RAWINPUTHEADER))==-1)
		{
			if((void *)h!=(void *)bfr)free(h);
			break;
		}
		q=h->hDevice;
		t=h->dwType;
		if((void *)h!=(void *)bfr)free(h);
		if(gd((HRAWINPUT)lParam,RID_INPUT,NULL,&u,sizeof(RAWINPUTHEADER)))break;
		if(u<=sizeof(bfr))r=(RAWINPUT *)bfr;
		else if(!(r=malloc(u)))break;
		if(gd((HRAWINPUT)lParam,RID_INPUT,r,&u,sizeof(RAWINPUTHEADER))==-1)
		{
			if((void *)r!=(void *)bfr)free(r);
			break;
		}

		if(t==RIM_TYPEMOUSE)
		{
			if(r->data.mouse.ulExtraInformation==0xdeadbeef)
			{
				if((void *)r!=(void *)bfr)free(r);
				break;
			}
			j[1].type=INPUT_MOUSE;
			j[1].mi.dx=r->data.mouse.lLastX;
			j[1].mi.dy=r->data.mouse.lLastY;
			j[1].mi.dwFlags=0;
			if(r->data.mouse.usButtonFlags&RI_MOUSE_WHEEL)
			{
				j[1].mi.mouseData=((SHORT)r->data.mouse.usButtonData);
				j[1].mi.dwFlags|=MOUSEEVENTF_WHEEL;
			}
			else if(q==d->m&&!r->data.mouse.usButtonFlags&&(GetKeyState(d->k)&0x8000))
			{
				f=1;
				j[0].type=INPUT_KEYBOARD;
				j[0].ki.wVk=d->k;
				j[0].ki.dwFlags=KEYEVENTF_KEYUP;
				j[0].ki.time=0;
				j[0].ki.dwExtraInfo=0xdeadbeef;
				if(r->data.mouse.usFlags&MOUSE_MOVE_ABSOLUTE)j[1].mi.mouseData=0;
				else j[1].mi.mouseData=-(r->data.mouse.lLastY*4);
				j[1].mi.dwFlags|=MOUSEEVENTF_WHEEL;
				j[1].mi.dx=0;
				j[1].mi.dy=0;
				j[2].type=INPUT_KEYBOARD;
				j[2].ki.wVk=d->k;
				j[2].ki.dwFlags=0;
				j[2].ki.time=0;
				j[2].ki.dwExtraInfo=0xdeadbeef;
			}
			else
			{
				j[1].mi.mouseData=0;
				if(r->data.mouse.usButtonFlags&(RI_MOUSE_BUTTON_4_DOWN|RI_MOUSE_BUTTON_4_UP))
				{
					if(r->data.mouse.usButtonFlags&RI_MOUSE_BUTTON_4_DOWN)j[1].mi.dwFlags|=MOUSEEVENTF_XDOWN;
					else j[1].mi.dwFlags|=MOUSEEVENTF_XUP;
					j[1].mi.mouseData|=XBUTTON1;
				}
				if(r->data.mouse.usButtonFlags&(RI_MOUSE_BUTTON_5_DOWN|RI_MOUSE_BUTTON_5_UP))
				{
					if(r->data.mouse.usButtonFlags&RI_MOUSE_BUTTON_5_DOWN)j[1].mi.dwFlags|=MOUSEEVENTF_XDOWN;
					else j[1].mi.dwFlags|=MOUSEEVENTF_XUP;
					j[1].mi.mouseData|=XBUTTON2;
				}
			}
			if(!f)
			{
				if(r->data.mouse.usFlags&MOUSE_MOVE_ABSOLUTE)j[1].mi.dwFlags|=MOUSEEVENTF_ABSOLUTE|MOUSEEVENTF_MOVE;
				else if(j[1].mi.dx||j[1].mi.dy)j[1].mi.dwFlags|=MOUSEEVENTF_MOVE;
				if(r->data.mouse.usFlags&MOUSE_VIRTUAL_DESKTOP)j[1].mi.dwFlags|=MOUSEEVENTF_VIRTUALDESK;
			}
			if(r->data.mouse.usButtonFlags&RI_MOUSE_BUTTON_1_DOWN)j[1].mi.dwFlags|=MOUSEEVENTF_LEFTDOWN;
			if(r->data.mouse.usButtonFlags&RI_MOUSE_BUTTON_1_UP)j[1].mi.dwFlags|=MOUSEEVENTF_LEFTUP;
			if(r->data.mouse.usButtonFlags&RI_MOUSE_BUTTON_2_DOWN)j[1].mi.dwFlags|=MOUSEEVENTF_RIGHTDOWN;
			if(r->data.mouse.usButtonFlags&RI_MOUSE_BUTTON_2_UP)j[1].mi.dwFlags|=MOUSEEVENTF_RIGHTUP;
			if(r->data.mouse.usButtonFlags&RI_MOUSE_BUTTON_3_DOWN)j[1].mi.dwFlags|=MOUSEEVENTF_MIDDLEDOWN;
			if(r->data.mouse.usButtonFlags&RI_MOUSE_BUTTON_3_UP)j[1].mi.dwFlags|=MOUSEEVENTF_MIDDLEUP;
			j[1].mi.time=0;
			j[1].mi.dwExtraInfo=0xdeadbeef;
			if(f)SendInput(3,j,sizeof(INPUT));
			else SendInput(1,&j[1],sizeof(INPUT));
			if((void *)r!=(void *)bfr)free(r);
			break;
		}
		else if((void *)r!=(void *)bfr)free(r);
		break;
	}

	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}

static DWORD WINAPI looper(LPVOID param)
{
	DATA *d=param;
	MSG msg;
	RAWINPUTDEVICE dr;
	HHOOK hmll;

	TlsSetValue(th,d);

	EnterCriticalSection(&mtx);
	if(!(d->w=CreateWindow(wndcls,"",CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,HWND_MESSAGE,NULL,inst,NULL)))
	{
		LeaveCriticalSection(&mtx);
		goto e1;
	}
	LeaveCriticalSection(&mtx);

	dr.usUsagePage=1;
	dr.usUsage=2;
	dr.hwndTarget=d->w;
	dr.dwFlags=RIDEV_INPUTSINK;

	if(!gr(&dr,1,sizeof(RAWINPUTDEVICE)))goto e2;
	if(!(hmll=SetWindowsHookEx(WH_MOUSE_LL,llmp,inst,0)))goto e3;

	while(GetMessage(&msg,d->w,WM_INPUT,WM_INPUT))
	{
		if(msg.wParam==-1)break;
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	if(d->m)UnhookWindowsHookEx(hmll);

e3:	dr.usUsagePage=1;
	dr.usUsage=2;
	dr.hwndTarget=d->w;
	dr.dwFlags=RIDEV_REMOVE;
	gr(&dr,1,sizeof(RAWINPUTDEVICE));
e2:	DestroyWindow(d->w);
e1:	SetEvent(d->e);
	ExitThread(0);
}

BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	HMODULE user32;
	WNDCLASS w;
	DATA *d;

	switch(fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		inst=hinstDLL;
		enabled=0;
		user32=LoadLibrary("user32.dll");
		if(!(gl=(pGetRawInputDeviceList)GetProcAddress(user32,"GetRawInputDeviceList")))break;
		if(!(gi=(pGetRawInputDeviceInfoA)GetProcAddress(user32,"GetRawInputDeviceInfoA")))break;
		if(!(gd=(pGetRawInputData)GetProcAddress(user32,"GetRawInputData")))break;
		if(!(gr=(pRegisterRawInputDevices)GetProcAddress(user32,"RegisterRawInputDevices")))break;
		memset(&w,0,sizeof(w));
		w.lpfnWndProc=wp;
		w.hInstance=hinstDLL;
		w.lpszClassName=wndcls;
		if(!(a=RegisterClass(&w)))break;
		InitializeCriticalSection(&mtx);
		enabled=1;
		th=TlsAlloc();
		break;

	case DLL_THREAD_ATTACH:
		TlsSetValue(th,NULL);
		break;

	case DLL_THREAD_DETACH:
		if(!(d=TlsGetValue(th)))break;
		if(d)
		{
			if(d->m)free(d->m);
			free(d);
		}
		break;

	case DLL_PROCESS_DETACH:
		DeleteCriticalSection(&mtx);
		TlsFree(th);
		break;
	}

	return TRUE;
}

int __declspec(dllexport) tbwheel_init(char *mouse,int modifier)
{
	int i;
	int err=-1;
	int hit=0;
	UINT n;
	UINT l;
	char *name;
	PRAWINPUTDEVICELIST p;
	DATA *d;
	char b[26];

	if(!enabled)goto e0;
	if((d=TlsGetValue(th)))goto e0;
	if(!(d=malloc(sizeof(DATA))))goto e0;

	d->m=NULL;
	d->k=(modifier?VK_SHIFT:VK_CONTROL);

	if(!mouse)goto e1;

	if(gl(NULL,&n,sizeof(RAWINPUTDEVICELIST)))goto e1;
	if(!(p=(PRAWINPUTDEVICELIST)malloc(sizeof(RAWINPUTDEVICELIST)*n)))goto e1;
	if(gl(p,&n,sizeof(RAWINPUTDEVICELIST))==-1)goto e2;

	for(i=0;i<(int)n;i++)if(p[i].dwType==RIM_TYPEMOUSE)
	{
		if(gi(p[i].hDevice,RIDI_DEVICENAME,NULL,&l)==-1)continue;
		if(!(name=(char *)malloc(l)))continue;
		if(gi(p[i].hDevice,RIDI_DEVICENAME,name,&l)==-1)goto skip;
		if(!strncmp(name,"\\??\\Root#RDP_MOU#0000#",22))goto skip;
		name[l-1]=0;
		if(!strncmp(mouse,"USB,",4)&&strlen(mouse)==13&&mouse[8]==',')
		{
			strcpy(b,"\\??\\HID#Vid_");
			memcpy(b+12,mouse+4,4);
			strcpy(b+16,"&Pid_");
			memcpy(b+21,mouse+9,4);
			b[25]=0;
			if(!strncmp(name,b,25))goto match;
		}
		else if(!strcmp(name,mouse))
		{
match:		hit=1;
			d->m=p[i].hDevice;
			break;
		}
skip:	free(name);
	}

	if(!hit)goto e3;

	if(!(d->h=CreateThread(NULL,0,looper,d,CREATE_SUSPENDED,NULL)))goto e3;
	if(!(d->e=CreateEvent(NULL,FALSE,FALSE,NULL)))goto e4;
	d->w=NULL;
	TlsSetValue(th,d);
	ResumeThread(d->h);

	free(name);
	free(p);

	return 0;

e4: TerminateThread(d->h,0);
e3:	free(name);
	if(d->m)free(d->m);
e2:	free(p);
e1:	free(d);
e0:	return err;
}

void __declspec(dllexport) tbwheel_exit(void)
{
	DATA *d;
	int w=0;

	if(!enabled)return;
	if(!(d=TlsGetValue(th)))return;

	EnterCriticalSection(&mtx);
	if(d->w)
	{
		PostMessage(d->w,WM_INPUT,-1,0);
		w=1;
	}
	else TerminateThread(d->h,0);
	LeaveCriticalSection(&mtx);

	if(w)WaitForSingleObject(d->e,-1);
	CloseHandle(d->e);
	if(d->m)free(d->m);
	free(d);
	TlsSetValue(th,NULL);
}
