#define WINVER 0x0501
#define _WIN32_WINNT 0x0501
#include <windows.h>
#include <commctrl.h>
#include <mmsystem.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>

#include "tbwheeldll.h"
#include "tbwheel.h"
#include "numconv.h"

#define APSTUDIO_INVOKED
#include "resource1.h"

#define TRAY_CALLBACK (WM_USER+1)
#define TIMER_TICK    (WM_USER+2)

#define ntoa(p,n)								\
do												\
{												\
	if((n)<0||(n)>30000)p+=sprintf(p,"%d",(n));	\
	else										\
	{											\
		register char *z=(char *)numtab[(n)];	\
		while(*z)								\
		{										\
			*p++=*z++;							\
		}										\
	}											\
} while(0)

#define addstr(p,s)								\
do												\
{												\
	register char *z=(char *)(s);				\
	while(*z)									\
	{											\
		*p++=*z++;								\
	}											\
} while(0)

typedef WINUSERAPI INT (WINAPI *pGetRawInputDeviceList)(OUT PRAWINPUTDEVICELIST pRawInputDeviceList, IN OUT PUINT puiNumDevices, IN UINT cbSize);
typedef WINUSERAPI INT(WINAPI *pGetRawInputDeviceInfoA)(IN HANDLE hDevice, IN UINT uiCommand, OUT LPVOID pData, IN OUT PUINT pcbSize);

static HWND hWnd;
static HACCEL acc;
static HINSTANCE instance;
static NOTIFYICONDATA tnd;
static char tiphdr[64];
static int popup=0;
static int installed=0;
static char *currdev=NULL;
static int counter=0;
static UINT_PTR timer=0;
static DWORD modifier=1;

static int sub1[9]=
{
	ID_SHOWCFG_0,
	ID_SHOWCFG_1,
	ID_SHOWCFG_2,
	ID_SHOWCFG_3,
	ID_SHOWCFG_4,
	ID_SHOWCFG_5,
	ID_SHOWCFG_6,
	ID_SHOWCFG_7,
	ID_SHOWCFG_8
};

static char *dn[9]=
{
	"",
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL
};

static char *devlist(void)
{
	int i;
	HMODULE user32;
	UINT n;
	UINT l;
	char *name;
	char *pp;
	char *q;
	char *devtype;
	char *list;
	char *r;
	PRAWINPUTDEVICELIST p;
	pGetRawInputDeviceList gl;
	pGetRawInputDeviceInfoA gd;
	RID_DEVICE_INFO info;
	HKEY hkey;
	DWORD regtype;
	DWORD size;
	char vendorid[5];
	char deviceid[5];

	if(!(r=list=(char *)malloc(65536)))return NULL;
	*r=0;

	user32=LoadLibrary("user32.dll");
	gl=(pGetRawInputDeviceList)GetProcAddress(user32,"GetRawInputDeviceList");
	gd=(pGetRawInputDeviceInfoA)GetProcAddress(user32,"GetRawInputDeviceInfoA");

	if(gl&&gd)
	{
		if(gl(NULL,&n,sizeof(RAWINPUTDEVICELIST)))return list;
		if(!(p=(PRAWINPUTDEVICELIST)malloc(sizeof(RAWINPUTDEVICELIST)*n)))return list;
		if(gl(p,&n,sizeof(RAWINPUTDEVICELIST))==-1)return list;
		for(i=0;i<(int)n;i++)if(p[i].dwType==RIM_TYPEMOUSE)
		{
			*vendorid=0;
			*deviceid=0;
			if(gd(p[i].hDevice,RIDI_DEVICENAME,NULL,&l)==-1)continue;
			if(!(name=(char *)malloc(l)))continue;
			if(gd(p[i].hDevice,RIDI_DEVICENAME,name,&l)==-1)goto skip;
			if(!strncmp(name,"\\??\\Root#RDP_MOU#0000#",22))goto skip;
			name[l-1]=0;
			l=sizeof(info);
			info.cbSize=sizeof(RID_DEVICE_INFO);
			if(gd(p[i].hDevice,RIDI_DEVICEINFO,&info,&l)==-1)goto skip;
			devtype=NULL;
			if(strlen(name)>4)if((pp=strdup(name+4)))
			{
				for(q=pp;*q&&*q!='{';q++)if(*q=='#')*q='\\';
				*q=0;
				if(!strncmp(pp,"HID\\Vid_",8))
				{
					memcpy(vendorid,pp+8,4);
					vendorid[4]=0;
					if(strlen(vendorid)==4)
					{
						if(!strncmp(pp+12,"&Pid_",5))
						{
							memcpy(deviceid,pp+17,4);
							deviceid[4]=0;
							if(strlen(deviceid)!=4)
							{
								*vendorid=0;
								*deviceid=0;
							}
						}
						else *vendorid=0;
					}
				}
				if((q=(char *)malloc(strlen(pp)+31)))
				{
					strcpy(q,"System\\CurrentControlSet\\Enum\\");
					strcat(q,pp);
					if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,q,0,KEY_READ,&hkey)==ERROR_SUCCESS)
					{
						regtype=REG_SZ;
						if(RegQueryValueEx(hkey,"DeviceDesc",NULL,&regtype,NULL,&size)==ERROR_SUCCESS)
						{
							if((devtype=(char *)malloc(size)))
							{
								if(RegQueryValueEx(hkey,"DeviceDesc",NULL,&regtype,(LPBYTE)devtype,&size)!=ERROR_SUCCESS)
								{
									free(devtype);
									devtype=NULL;
								}
							}
						}
						RegCloseKey(hkey);
					}
					free(q);
				}
				free(pp);
			}
			if(*vendorid&&*deviceid)
			{
				addstr(r,"USB,");
				addstr(r,vendorid);
				*r++=',';
				addstr(r,deviceid);
			}
			else addstr(r,name);
			addstr(r," ");
			addstr(r,devtype?devtype:"Unknown Device");
			*r++=' ';
			ntoa(r,info.mouse.dwNumberOfButtons);
			addstr(r," Buttons\n");
			if(devtype)free(devtype);
skip:		free(name);
		}
		free(p);
	}

	return list;
}

static void settray(int mode)
{
	HICON icon;									// tray icon

	
	// load tray icon from resource

	icon=LoadImage(instance,MAKEINTRESOURCE(mode?IDI_TBWORK:IDI_TBNONE),IMAGE_ICON,GetSystemMetrics(SM_CXSMICON),GetSystemMetrics(SM_CYSMICON),LR_DEFAULTCOLOR);

	// prepare tray icon parameters

	tnd.hIcon  = icon;
	tnd.uFlags = NIF_ICON | NIF_TIP;

	// prepare tray tip text

	lstrcpy(tnd.szTip,TOOLTIPTXT);

	// install tray icon

	Shell_NotifyIcon(NIM_MODIFY,&tnd);

	// delete loaded icon

	DestroyIcon(icon);
}

static LRESULT CALLBACK MainWndProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	POINT pos;
	HMENU m1;
	HMENU m2;
	int newstate;
	MENUITEMINFO info;
	char *list;
	char *dev;
	char *dname;
	HKEY key;

	switch( msg )
	{
	case WM_TIMER:
		if(wParam!=TIMER_TICK)break;
		if(!counter)break;
		if(--counter)break;
		if(timer)KillTimer(hWnd,timer);
		timer=0;

		if(!currdev||!*currdev)break;
		if(!(list=devlist()))break;

		dev=strtok(list," ");
		dname=strtok(NULL,"\n");
		newstate=0;

		while(dev&&dname&&newstate<8)
		{
			newstate++;

			if(!strcmp(currdev,dev))
			{
				if(!installed)
				{
					installed=tbwheel_init(currdev,modifier)?0:1;
					settray(installed);
				}
				goto out;
			}
			dev=strtok(NULL," ");
			dname=strtok(NULL,"\n");
		}

		if(installed)
		{
			tbwheel_exit();
			settray(0);
		}
		installed=0;

out:	free(list);
		break;

	case WM_DEVICECHANGE:
		counter=3;
		if(!timer)timer=SetTimer(hWnd,TIMER_TICK,100,NULL);
		break;

	case TRAY_CALLBACK:
		if(lParam==WM_RBUTTONUP&&wParam==IDI_TBWHEEL&&!popup)
		{
			GetCursorPos(&pos);

			m1=LoadMenu(instance,MAKEINTRESOURCE(IDR_TBWHEEL));
			m2=GetSubMenu(m1,0);

			info.cbSize=sizeof(info);
			info.fMask=MIIM_STATE;
			info.fState=MFS_ENABLED|MFS_CHECKED;
			SetMenuItemInfo(m2,modifier?ID_MODIFIERKEY_SHIFT:ID_MODIFIERKEY_CTRL,0,&info);

			newstate=0;
			list=devlist();

			if(list)
			{
				dev=strtok(list," ");
				dname=strtok(NULL,"\n");
				newstate=0;

				while(dev&&dname&&newstate<8)
				{
					newstate++;

					info.cbSize=sizeof(info);
					info.fMask=MIIM_STATE|MIIM_TYPE;
					info.fType=MFT_STRING;
					info.fState=MFS_ENABLED;
					info.dwTypeData=dname;
					SetMenuItemInfo(m2,sub1[newstate],0,&info);
					if(dn[newstate])free(dn[newstate]);
					dn[newstate]=strdup(dev);

					dev=strtok(NULL," ");
					dname=strtok(NULL,"\n");
				}

				free(list);
			}

			while(newstate<8)
			{
				newstate++;
				DeleteMenu(m2,sub1[newstate],MF_BYCOMMAND);
				if(dn[newstate])free(dn[newstate]);
				dn[newstate]=NULL;
			}

			for(newstate=0;newstate<9&&dn[newstate];newstate++)
			{
				if(currdev)if(!strcmp(currdev,dn[newstate]))
				{
					info.cbSize=sizeof(info);
					info.fMask=MIIM_STATE;
					info.fState=MFS_ENABLED|MFS_CHECKED;
					SetMenuItemInfo(m2,sub1[newstate],0,&info);
					break;
				}
			}

			if(newstate==9||!dn[newstate])
			{
				info.cbSize=sizeof(info);
				info.fMask=MIIM_STATE;
				info.fState=MFS_ENABLED|MFS_CHECKED;
				SetMenuItemInfo(m2,sub1[0],0,&info);
			}

			SetForegroundWindow(hWnd);
			TrackPopupMenu(m2,TPM_LEFTBUTTON,pos.x,pos.y,0,hWnd,NULL);
			PostMessage(hWnd,WM_USER,0,0);
			DestroyMenu(m1);
		}
		break;

	case WM_ENDSESSION:
		if(!wParam)break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;

	case WM_COMMAND:
		switch(wParam)
		{
		case ID_EXIT:
			DestroyWindow(hWnd);
			break;

		case ID_ABOUT:
			popup++;
			MessageBox(NULL,"Trackball Wheel Emulator, (c) 2009 Andreas Steinmetz\n\nSelect mouse device and then press SHIFT or CTRL while\nmoving the mouse or the ball to emulate the mouse wheel.","Trackball Wheel Emulator",MB_OK|MB_TOPMOST|MB_SETFOREGROUND);
			popup--;
			break;

		case ID_MODIFIERKEY_SHIFT:
			modifier=1;
			goto modcmn;

		case ID_MODIFIERKEY_CTRL:
			modifier=0;
modcmn:		if(installed)settray(0);
			tbwheel_exit();
			installed=0;
			if(currdev&&*currdev)
			{
				Sleep(100);
				installed=tbwheel_init(currdev,modifier)?0:1;
				settray(installed);
			}
			if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,REGBASE,0,NULL,REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&key,NULL)==ERROR_SUCCESS)
			{
				RegSetValueEx(key,MODIFIER,0,REG_DWORD,(BYTE *)&modifier,sizeof(modifier));
				RegCloseKey(key);
			}
			break;

		case ID_SHOWCFG_0:
		case ID_SHOWCFG_1:
		case ID_SHOWCFG_2:
		case ID_SHOWCFG_3:
		case ID_SHOWCFG_4:
		case ID_SHOWCFG_5:
		case ID_SHOWCFG_6:
		case ID_SHOWCFG_7:
		case ID_SHOWCFG_8:
			for(newstate=0;newstate<9;newstate++)
			{
				if(sub1[newstate]==wParam)
				{
					if(currdev)free(currdev);
					currdev=strdup(dn[newstate]);
					if(installed)settray(0);
					tbwheel_exit();
					installed=0;
					if(currdev&&*currdev)
					{
						Sleep(100);
						installed=tbwheel_init(currdev,modifier)?0:1;
						settray(installed);
					}
					if(RegCreateKeyEx(HKEY_LOCAL_MACHINE,REGBASE,0,NULL,REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&key,NULL)==ERROR_SUCCESS)
					{
						RegSetValueEx(key,DEVNAME,0,REG_SZ,currdev?currdev:"",lstrlen(currdev?currdev:"")+1);
						RegCloseKey(key);
					}
				}
			}
			break;
		}
		break;

	default:
		return DefWindowProc(hWnd,msg,wParam,lParam);
	}

	return 0;
}
	
INT WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	char name[32];								// class name, window title
	HICON icon;									// tray icon
	WNDCLASS wc;								// window class
	MSG msg;									// message
	HWND hWnd;									// window handle
	HKEY key;
	int len;
	char *list;
	char *dev;
	char *dname;

	instance=hInstance;

	lstrcpy(name,"tbwheel process");

	if(FindWindow(name,name))ExitProcess(1);

	// prepare window class data

	wc.lpszClassName = name;
	wc.lpfnWndProc   = MainWndProc;
	wc.style         = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = NULL;
	wc.hCursor       = NULL;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName  = NULL;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;

	// register window class

	RegisterClass( &wc );

	// create window (only required for message processing)

	hWnd = CreateWindow(name,name,0,0,0,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInstance,NULL);

	// load tray icon from resource

	icon = LoadImage(hInstance,MAKEINTRESOURCE(IDI_TBWHEEL),IMAGE_ICON,GetSystemMetrics(SM_CXSMICON),GetSystemMetrics(SM_CYSMICON),LR_DEFAULTCOLOR);

	// prepare tray icon parameters

	tnd.uID              = IDI_TBWHEEL;
	tnd.cbSize           = sizeof(NOTIFYICONDATA);
	tnd.hWnd             = hWnd;
	tnd.uCallbackMessage = TRAY_CALLBACK;
	tnd.hIcon            = icon;
	tnd.uFlags           = NIF_MESSAGE | NIF_ICON | NIF_TIP;

	// prepare tray tip text

	lstrcpy(tnd.szTip,TOOLTIPTXT);

	// install tray icon

	Shell_NotifyIcon(NIM_ADD,&tnd);

	// delete loaded icon

	DestroyIcon(icon);

	if(RegOpenKeyEx(HKEY_LOCAL_MACHINE,REGBASE,0,KEY_READ,&key)==ERROR_SUCCESS)
	{
		if(RegQueryValueEx(key,DEVNAME,NULL,NULL,NULL,&len)==ERROR_SUCCESS)
			if((currdev=malloc(len+2)))
				RegQueryValueEx(key,DEVNAME,NULL,NULL,currdev,&len);
		len=sizeof(modifier);
		if(RegQueryValueEx(key,MODIFIER,NULL,NULL,(LPBYTE)&modifier,&len)!=ERROR_SUCCESS)modifier=1;
		RegCloseKey(key);
	}

	if(currdev&&*currdev)
	{
		list=devlist();

		if(list)
		{
			dev=strtok(list," ");
			dname=strtok(NULL,"\n");
			len=0;

			while(dev&&dname&&len<8)
			{
				len++;

				if(!strcmp(currdev,dev))
				{
					installed=tbwheel_init(currdev,modifier)?0:1;
					break;
				}

				dev=strtok(NULL," ");
				dname=strtok(NULL,"\n");
			}

			free(list);
		}
	}

	settray(installed);

	// message pump

	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	// stop timer if it is running

	if(timer)KillTimer(hWnd,timer);

	// remove tray icon

	tnd.uFlags = 0;
	Shell_NotifyIcon(NIM_DELETE,&tnd);


	tbwheel_exit();
	installed=0;

	return FALSE;
}
